/* Main sysmask file.
 * 
 * Copyright: (C) 2005 Gang Xiao <xiao@unice.fr>
 */

/* #define SMK_DISABLE 1 */

#define _SYSMASK_C

#include <linux/sys.h>
#include <asm/unistd.h>
#include <linux/sched.h>
#include <linux/file.h>
#include <asm/uaccess.h>
#include <linux/fs.h>
#include <linux/mount.h>
#include <linux/mm.h>
#include <linux/sysmask.h>
#include <linux/version.h>

#if LINUX_VERSION_CODE < 0x20500
# define LINUX_2_4 1
#else
# define LINUX_2_6 1
# include <linux/namei.h>
#endif

extern int sys_kill(int pid, int sig);

int sysmask_tab[]={
SM1_NEW,		/* 0, __NR_restart_syscall, sys_restart_syscall */
0,			/* __NR_exit, sys_exit */
SM1_FORK,		/* __NR_fork, sys_fork */
0,			/* __NR_read, sys_read */
0,			/* __NR_write, sys_write */
SM1_OPEN,		/* __NR_open, sys_open */
0,			/* __NR_close, sys_close */
SM1_FORK,		/* __NR_waitpid, sys_waitpid */
SM1_OPEN,		/* __NR_creat, sys_creat */
SM1_LINK,		/* __NR_link, sys_link */

SM1_ERASE,		/* 10, __NR_unlink, sys_unlink */
SM1_EXECVE,		/* __NR_execve, sys_execve */
SM1_CHDIR,		/* __NR_chdir, sys_chdir */
SM1_HARMLESS,		/* __NR_time, sys_time,  */
SM1_MOUNT,		/* __NR_mknod, sys_mknod */
SM1_CHMOD,		/* __NR_chmod, sys_chmod */
SM1_ROOTMISC,		/* __NR_lchown, sys_lchown16 */
SM1_NONSTD,		/* __NR_break, sys_ni_syscall */
SM1_OBSOLETE|SM1_DREAD,	/* __NR_oldstat, sys_stat */
SM1_FNOHARM,		/* __NR_lseek, sys_lseek */

SM1_HARMLESS,		/* 20, __NR_getpid, sys_getpid */
SM1_MOUNT,		/* __NR_mount, sys_mount,  */
SM1_MOUNT,		/* __NR_umount, sys_oldumount */
0,			/* __NR_setuid, sys_setuid16 */
SM1_HARMLESS,		/* __NR_getuid, sys_getuid16 */
SM1_SYSADM,		/* __NR_stime, sys_stime,  */
SM1_MISC,		/* __NR_ptrace, sys_ptrace */
SM1_SIGNAL,		/* __NR_alarm, sys_alarm */
SM1_DREAD|SM1_OBSOLETE,	/* __NR_oldfstat, sys_fstat */
SM1_HARMLESS,		/* __NR_pause, sys_pause */

SM1_CHMOD,		/* 30, __NR_utime, sys_utime */
SM1_NONSTD,		/* __NR_stty, sys_ni_syscall */
SM1_NONSTD,		/* __NR_gtty, sys_ni_syscall */
SM1_DREAD,		/* __NR_access, sys_access */
SM1_RLIM,		/* __NR_nice, sys_nice */
SM1_NONSTD,		/* __NR_ftime, sys_ni_syscall */
SM1_FNOHARM,		/* __NR_sync, sys_sync */
SM1_KILL,		/* __NR_kill, sys_kill */
SM1_LINK,		/* __NR_rename, sys_rename */
SM1_DIR,		/* __NR_mkdir, sys_mkdir */

SM1_DIR|SM1_ERASE,	/* 40, __NR_rmdir, sys_rmdir */
SM1_FMISC,		/* __NR_dup, sys_dup */
SM1_FMISC,		/* __NR_pipe, sys_pipe */
SM1_HARMLESS,		/* __NR_times, sys_times */
SM1_NONSTD,		/* __NR_prof, sys_ni_syscall */
SM1_BRK,		/* __NR_brk, sys_brk */
0,			/* __NR_setgid, sys_setgid16 */
SM1_HARMLESS,		/* __NR_getgid, sys_getgid16 */
SM1_SIGNAL,		/* __NR_signal, sys_signal */
SM1_HARMLESS,		/* __NR_geteuid, sys_geteuid16 */

SM1_HARMLESS,		/* 50, __NR_getegid, sys_getegid16 */
SM1_SYSADM,		/* __NR_acct, sys_acct */
SM1_MOUNT,		/* __NR_umount2, sys_umount */
SM1_NONSTD,		/* __NR_lock, sys_ni_syscall */
SM1_IOCTL,		/* __NR_ioctl, sys_ioctl */
SM1_OPEN|SM1_FMISC,	/* __NR_fcntl, sys_fcntl */
SM1_SYSMASK,		/* __NR_mpx, sys_ni_syscall */  /* Hijacked by sys_sysmask. */
SM1_SPID,		/* __NR_setpgid, sys_setpgid */
SM1_NONSTD,		/* __NR_ulimit, sys_ni_syscall */
SM1_OBSOLETE,		/* __NR_oldolduname, sys_olduname */

SM1_CHMOD,		/* 60, __NR_umask, sys_umask */
SM1_CHROOT,		/* __NR_chroot, sys_chroot */
SM1_FS,			/* __NR_ustat, sys_ustat */
SM1_FMISC,		/* __NR_dup2, sys_dup2 */
SM1_HARMLESS,		/* __NR_getppid, sys_getppid */
SM1_HARMLESS,		/* __NR_getpgrp, sys_getpgrp */
SM1_SPID,		/* __NR_setsid, sys_setsid */
SM1_SIGNAL,		/* __NR_sigaction, sys_sigaction */
SM1_SIGNAL,		/* __NR_sgetmask, sys_sgetmask */
SM1_SIGNAL,		/* __NR_ssetmask, sys_ssetmask */

0,			/* 70, __NR_setreuid, sys_setreuid16 */
0,			/* __NR_setregid, sys_setregid16 */
SM1_SIGNAL,		/* __NR_sigsuspend, sys_sigsuspend */
SM1_SIGNAL,		/* __NR_sigpending, sys_sigpending */
SM1_SYSADM,		/* __NR_sethostname, sys_sethostname */
SM1_RLIM,		/* __NR_setrlimit, sys_setrlimit */
SM1_RLIM,		/* __NR_getrlimit, sys_old_getrlimit */
SM1_RLIM,		/* __NR_getrusage, sys_getrusage */
SM1_HARMLESS,		/* __NR_gettimeofday, sys_gettimeofday */
SM1_SYSADM,		/* __NR_settimeofday, sys_settimeofday */

SM1_HARMLESS,		/* 80, __NR_getgroups, sys_getgroups16 */
0,			/* __NR_setgroups, sys_setgroups16 */
SM1_POLL,		/* __NR_select, old_select */
SM1_LINK,		/* __NR_symlink, sys_symlink */
SM1_OBSOLETE|SM1_DREAD, /* __NR_oldlstat, sys_lstat */
SM1_DREAD,		/* __NR_readlink, sys_readlink */
SM1_OBSOLETE,		/* __NR_uselib, sys_uselib */
SM1_MOUNT,		/* __NR_swapon, sys_swapon */
SM1_ROOTMISC,		/* __NR_reboot, sys_reboot */
SM1_OBSOLETE,		/* __NR_readdir, old_readdir,  */

SM1_MMAP,		/* 90, __NR_mmap, old_mmap */
SM1_MMAP,		/* __NR_munmap, sys_munmap */
SM1_ERASE,		/* __NR_truncate, sys_truncate */
SM1_FMISC,		/* __NR_ftruncate, sys_ftruncate */
SM1_CHMOD,		/* __NR_fchmod, sys_fchmod */
SM1_ROOTMISC,		/* __NR_fchown, sys_fchown16 */
SM1_RLIM,		/* __NR_getpriority, sys_getpriority */
SM1_RLIM,		/* __NR_setpriority, sys_setpriority */
SM1_NONSTD,		/* __NR_profil, sys_ni_syscall */
SM1_FS,			/* __NR_statfs, sys_statfs */

SM1_FS,			/* 100, __NR_fstatfs, sys_fstatfs */
SM1_ROOTMISC|SM1_NONSTD,/* __NR_ioperm, sys_ioperm */
SM1_SOCKETCALL,		/* __NR_socketcall, sys_socketcall */
SM1_ROOTMISC,		/* __NR_syslog, sys_syslog */
SM1_RLIM,		/* __NR_setitimer, sys_setitimer */
SM1_RLIM,		/* __NR_getitimer, sys_getitimer */
SM1_DREAD,		/* __NR_stat, sys_newstat */
SM1_DREAD,		/* __NR_lstat, sys_newlstat */
SM1_DREAD,		/* __NR_fstat, sys_newfstat */
SM1_OBSOLETE,		/* __NR_olduname, sys_uname */

SM1_ROOTMISC|SM1_NONSTD,/* 110, __NR_iopl, sys_iopl */
SM1_ROOTMISC|SM1_NONSTD,/* __NR_vhangup, sys_vhangup */
SM1_NONSTD,		/* __NR_idle, sys_ni_syscall */
SM1_OBSOLETE,		/* __NR_vm86old, sys_vm86old */
SM1_FORK,		/* __NR_wait4, sys_wait4 */
SM1_MOUNT,		/* __NR_swapoff, sys_swapoff */
SM1_NONSTD,		/* __NR_sysinfo, sys_sysinfo */
SM1_IPC,		/* __NR_ipc, sys_ipc */
SM1_FNOHARM,		/* __NR_fsync, sys_fsync */
SM1_SIGNAL,		/* __NR_sigreturn, sys_sigreturn */

SM1_FORK,		/* 120, __NR_clone, sys_clone */
SM1_SYSADM|SM1_NONSTD,	/* __NR_setdomainname, sys_setdomainname */
SM1_HARMLESS,		/* __NR_uname, sys_newuname */
SM1_LDT,		/* __NR_modify_ldt, sys_modify_ldt */
SM1_SYSADM|SM1_NONSTD,	/* __NR_adjtimex, sys_adjtimex */
SM1_MMAP,		/* __NR_mprotect, sys_mprotect */
SM1_SIGNAL,		/* __NR_sigprocmask, sys_sigprocmask */
SM1_SYSADM|SM1_NONSTD,	/* __NR_create_module, sys_create_module */
SM1_SYSADM|SM1_NONSTD,	/* __NR_init_module, sys_init_module */
SM1_SYSADM|SM1_NONSTD,	/* __NR_delete_module, sys_delete_module */

SM1_SYSADM|SM1_NONSTD,	/* 130, __NR_get_kernel_syms, sys_get_kernel_syms */
SM1_SYSADM,		/* __NR_quotactl, sys_quotactl */
SM1_SPID,		/* __NR_getpgid, sys_getpgid */
SM1_CHDIR,		/* __NR_fchdir, sys_fchdir */
SM1_NONSTD|SM1_ROOTMISC,/* __NR_bdflush, sys_bdflush */
SM1_FS,			/* __NR_sysfs, sys_sysfs */
SM1_NONSTD,		/* __NR_personality, sys_personality */
SM1_NONSTD,		/* __NR_afs_syscall, sys_ni_syscall */
SM1_NONSTD,		/* __NR_setfsuid, sys_setfsuid16 */
SM1_NONSTD,		/* __NR_setfsgid, sys_setfsgid16 */

SM1_FNOHARM,		/* 140, __NR__llseek, sys_llseek */
SM1_DREAD,		/* __NR_getdents, sys_getdents */
SM1_POLL,		/* __NR__newselect, sys_select */
SM1_FMISC,		/* __NR_flock, sys_flock */
SM1_MMAP|SM1_FNOHARM,	/* __NR_msync, sys_msync */
SM1_HARMLESS,		/* __NR_readv, sys_readv */
SM1_HARMLESS,		/* __NR_writev, sys_writev */
SM1_SPID,		/* __NR_getsid, sys_getsid */
SM1_FNOHARM,		/* __NR_fdatasync, sys_fdatasync */
SM1_SYSADM|SM1_NONSTD,	/* __NR_sysctl, sys_sysctl */

SM1_ROOTMISC,		/* 150, __NR_mlock, sys_mlock */
SM1_ROOTMISC,		/* __NR_munlock, sys_munlock */
SM1_ROOTMISC,		/* __NR_mlockall, sys_mlockall */
SM1_ROOTMISC,		/* __NR_munlockall, sys_munlockall */
SM1_ROOTMISC,		/* __NR_sched_setparam, sys_sched_setparam */
SM1_ROOTMISC,		/* __NR_sched_getparam, sys_sched_getparam */
SM1_ROOTMISC,		/* __NR_sched_setscheduler, sys_sched_setscheduler */
SM1_ROOTMISC,		/* __NR_sched_getscheduler, sys_sched_getscheduler */
SM1_RLIM,		/* __NR_sched_yield, sys_yield */
SM1_RLIM,		/* __NR_sched_get_priority_max, sys_sched_get_priority_max */

SM1_RLIM,		/* 160, __NR_sched_get_priority_min, sys_sched_get_priority_min */
SM1_ROOTMISC,		/* __NR_sched_rr_get_interval, sys_sched_rr_get_interval */
SM1_HARMLESS,		/* __NR_nanosleep, sys_nanosleep */
SM1_MMAP|SM1_NONSTD,	/* __NR_mremap, sys_mremap */
SM1_NONSTD,		/* __NR_setresuid, sys_setresuid16 */
SM1_NONSTD,		/* __NR_getresuid, sys_getresuid16 */
SM1_NONSTD,		/* __NR_vm86, sys_vm86 */
SM1_SYSADM|SM1_NONSTD,	/* __NR_query_module, sys_query_module */
SM1_POLL,		/* __NR_poll, sys_poll */
SM1_SYSADM|SM1_NONSTD,	/* __NR_nfsservctl, sys_nfsservctl */

SM1_NONSTD,		/* 170, __NR_setresgid, sys_setresgid16 */
SM1_NONSTD,		/* __NR_getresgid, sys_getresgid16 */
SM1_NONSTD|SM1_KILL,	/* __NR_prctl, sys_prctl */
SM1_SIGNAL,		/* __NR_rt_sigreturn, sys_rt_sigreturn */
SM1_SIGNAL,		/* __NR_rt_sigaction, sys_rt_sigaction */
SM1_SIGNAL,		/* __NR_rt_sigprocmask, sys_rt_sigprocmask */
SM1_SIGNAL,		/* __NR_rt_sigpending, sys_rt_sigpending */
SM1_SIGNAL,		/* __NR_rt_sigtimedwait, sys_rt_sigtimedwait */
SM1_SIGNAL,		/* __NR_rt_sigqueueinfo, sys_rt_sigqueueinfo */
SM1_SIGNAL,		/* __NR_rt_sigsuspend, sys_rt_sigsuspend */

SM1_HARMLESS,		/* 180, __NR_pread64, sys_pread64 */
SM1_HARMLESS,		/* __NR_pwrite64, sys_pwrite64 */
SM1_ROOTMISC,		/* __NR_chown, sys_chown16 */
SM1_DREAD,		/* __NR_getcwd, sys_getcwd */
SM1_SYSMASK,		/* __NR_capget, sys_capget */
SM1_SYSMASK,		/* __NR_capset, sys_capset */
SM1_SIGNAL|SM1_NONSTD,	/* __NR_sigaltstack, sys_sigaltstack */
SM1_NONSTD,		/* __NR_sendfile, sys_sendfile */
SM1_NONSTD,		/* __NR_getpmsg, sys_ni_syscall */
SM1_NONSTD,		/* __NR_putpmsg, sys_ni_syscall */

SM1_FORK,		/* 190, __NR_vfork, sys_vfork */
SM1_RLIM,		/* __NR_ugetrlimit, sys_getrlimit */
SM1_MMAP,		/* __NR_mmap2, sys_mmap2 */
SM1_ERASE,		/* __NR_truncate64, sys_truncate64 */
SM1_FMISC,		/* __NR_ftruncate64, sys_ftruncate64 */
SM1_DREAD,		/* __NR_stat64, sys_stat64 */
SM1_DREAD,		/* __NR_lstat64, sys_lstat64 */
SM1_DREAD,		/* __NR_fstat64, sys_fstat64 */
SM1_ROOTMISC,		/* __NR_lchown, sys_lchown */
SM1_HARMLESS,		/* __NR_getuid, sys_getuid */

SM1_HARMLESS,		/* 200, __NR_getgid, sys_getgid */
SM1_HARMLESS,		/* __NR_geteuid, sys_geteuid */
SM1_HARMLESS,		/* __NR_getegid, sys_getegid */
0,			/* __NR_setreuid, sys_setreuid */
0,			/* __NR_setregid, sys_setregid */
SM1_HARMLESS,		/* __NR_getgroups, sys_getgroups */
0,			/* __NR_setgroups, sys_setgroups */
SM1_ROOTMISC,		/* __NR_fchown, sys_fchown */
SM1_NONSTD,		/* __NR_setresuid, sys_setresuid */
SM1_NONSTD,		/* __NR_getresuid, sys_getresuid */

SM1_NONSTD,		/* 210 __NR_setresgid, sys_setresgid */
SM1_NONSTD,		/* __NR_getresgid, sys_getresgid */
SM1_ROOTMISC,		/* __NR_chown, sys_chown */
0,			/* __NR_setuid, sys_setuid */
0,			/* __NR_setgid, sys_setgid */
SM1_NONSTD,		/* __NR_setfsuid, sys_setfsuid */
SM1_NONSTD,		/* __NR_setfsgid, sys_setfsgid */
SM1_ROOTMISC|SM1_NONSTD,/* __NR_pivot_root, sys_pivot_root */
SM1_ROOTMISC|SM1_NONSTD,/* __NR_mincore, sys_mincore */
SM1_ROOTMISC|SM1_NONSTD,/* __NR_madvise, sys_madvise */

SM1_DREAD,		/* 220, __NR_getdents64, sys_getdents64 */
SM1_OPEN|SM1_FMISC,	/* __NR_fcntl64, sys_fcntl64 */
SM1_NEW,		/* 222, sys_ni_syscall */
SM1_NEW,		/* 223, sys_ni_syscall */
SM1_HARMLESS,		/* __NR_gettid, sys_gettid */
SM1_NONSTD,		/* __NR_readahead, sys_readahead */
SM1_CHMOD,		/* __NR_setxattr, sys_setxattr */
SM1_CHMOD,		/* __NR_lsetxattr, sys_lsetxattr */
SM1_CHMOD,		/* __NR_fsetxattr, sys_fsetxattr */
SM1_DREAD,		/* __NR_getxattr, sys_getxattr */

SM1_DREAD,		/* 230, __NR_lgetxattr, sys_lgetxattr */
SM1_DREAD,		/* __NR_fgetxattr, sys_fgetxattr */
SM1_DREAD,		/* __NR_listxattr, sys_listxattr */
SM1_DREAD,		/* __NR_llistxattr, sys_llistxattr */
SM1_DREAD,		/* __NR_flistxattr, sys_flistxattr */
SM1_CHMOD,		/* __NR_removexattr, sys_removexattr */
SM1_CHMOD,		/* __NR_lremovexattr, sys_lremovexattr */
SM1_CHMOD,		/* __NR_fremovexattr, sys_fremovexattr */
SM1_KILL|SM1_NONSTD,	/* __NR_tkill, sys_tkill */
SM1_NONSTD,		/* __NR_sendfile64, sys_sendfile64 */

SM1_NONSTD,		/* 240, __NR_futex, sys_futex */
SM1_NONSTD|SM1_ROOTMISC,/* __NR_sched_setaffinity, sys_sched_setaffinity */
SM1_NONSTD|SM1_ROOTMISC,/* __NR_sched_getaffinity, sys_sched_getaffinity */
SM1_NONSTD|SM1_MISC,	/* __NR_set_thread_area, sys_set_thread_area */
SM1_NONSTD|SM1_MISC,	/* __NR_get_thread_area, sys_get_thread_area */
SM1_NONSTD|SM1_RT,	/* __NR_io_setup, sys_io_setup */
SM1_NONSTD|SM1_RT,	/* __NR_io_destroy, sys_io_destroy */
SM1_NONSTD|SM1_RT,	/* __NR_io_getevents, sys_io_getevents */
SM1_NONSTD|SM1_RT,	/* __NR_io_submit, sys_io_submit */
SM1_NONSTD|SM1_RT,	/* __NR_io_cancel, sys_io_cancel */

SM1_NONSTD,		/* 250, __NR_fadvise64, sys_fadvise64 */
SM1_NEW,		/* 251, sys_ni_syscall */
0,			/* __NR_exit_group, sys_exit_group */
SM1_NONSTD|SM1_DREAD,	/* __NR_lookup_dcookie, sys_lookup_dcookie */
SM1_NONSTD|SM1_POLL,	/* __NR_epoll_create, sys_epoll_create */
SM1_NONSTD|SM1_POLL,	/* __NR_epoll_ctl, sys_epoll_ctl */
SM1_NONSTD|SM1_POLL,	/* __NR_epoll_wait, sys_epoll_wait */
SM1_NONSTD|SM1_MMAP,	/* __NR_remap_file_pages, sys_remap_file_pages */
SM1_NONSTD,		/* __NR_set_tid_address, sys_set_tid_address */
SM1_NONSTD|SM1_RT,	/* __NR_timer_create, sys_timer_create */

SM1_NONSTD|SM1_RT,	/* 260, __NR_timer_settime, sys_timer_settime */
SM1_NONSTD|SM1_RT,	/* __NR_timer_gettime, sys_timer_gettime */
SM1_NONSTD|SM1_RT,	/* __NR_timer_getoverrun, sys_timer_getoverrun */
SM1_NONSTD|SM1_RT,	/* __NR_timer_delete, sys_timer_delete */
SM1_NONSTD|SM1_RT,	/* __NR_clock_settime, sys_clock_settime */
SM1_HARMLESS,		/* __NR_clock_gettime, sys_clock_gettime */
SM1_NONSTD|SM1_RT,	/* __NR_clock_getres, sys_clock_getres */
SM1_NONSTD|SM1_RT,	/* __NR_clock_nanosleep, sys_clock_nanosleep */
SM1_NONSTD|SM1_FS,	/* __NR_statfs64, sys_statfs64 */
SM1_NONSTD|SM1_FS,	/* __NR_fstatfs64, sys_fstatfs64 */
};

#define NR_sysmasks (sizeof(sysmask_tab)/sizeof(sysmask_tab[0]))

pid_t smk_daemon_pid;
uid_t sysmask_denyid;
struct task_struct *smk_daemon_task;
spinlock_t smkreq_lock;
struct smkd_request smk_req;
int smk_req_flags;
static atomic_t smkd_tick_time;
static atomic_t smk_sescnt;
static long int smk_session_inited = 0;
long int smk_ses_next_id = 0;
pid_t smk_reqpid, smk_waiting;
int smk_req_result;
struct vfsmount *smkd_rootmnt;
struct dentry *smkd_root;

	/* allocate a new session */
#define _smk_getsession() (struct smk_session *) __get_free_pages(GFP_KERNEL,1);
	/* free a session page */
#define _smk_putsession(x) free_pages((unsigned long) x,1);

long smk_kill(struct task_struct *p)
{
    struct siginfo info;

    info.si_signo = SIGKILL;
    info.si_errno = 0;
    info.si_code = SI_USER;
    info.si_pid = current->pid;
    info.si_uid = current->uid;
    
    return send_sig_info(SIGKILL, &info, p);
}

	/* Returns non-zero if should be killed */
static int _ultimatum(void)
{
    int i;
    struct smk_session *ses;
    unsigned long t, nowsec;
    struct timeval now;

    do_gettimeofday(&now); nowsec=now.tv_sec;
    for(i=0; i<SMK_SESSIONS; i++) {
	ses = current->smk_ses[i];
	if(!ses) continue;
	t = ses->rlim[SMK_RLIM_TIMEOUT];
	if(t && nowsec >= t) {
	    smk_kill(current);
	    return -EPERM;
	}
    }
    return 0;
}

static void _smk_init_ses(void)
{
    current->smk.token = 0;
    current->smk_ses[0] = NULL;
    current->smk_ses[1] = NULL;
    smk_session_inited = 1;
    atomic_set(&smk_sescnt, 0);
}

static void _smk_session_decrease(struct smk_session *ses)
{
    if(!ses) return;
    if(atomic_dec_and_test(&ses->rstatus[SMK_RLIM_NPROC])) {
	_smk_putsession(ses);
	atomic_dec(&smk_sescnt);
    }
}

static void _smk_new_session(long old_token, long token, long *rlim, long killid)
{
    int i;
    long t1, t2;
    struct timeval now;
    struct smk_session *ses, *oldses;

    for(i = 0; i < SMK_SESSIONS; i++) {
	t1 = (token>>(i*16))&0xFFFF;
	t2 = (old_token>>(i*16))&0xFFFF;
	if(t1 == t2) continue;
	oldses=current->smk_ses[i];
	if(oldses) {
	    if(t1) {
		atomic_inc(&oldses->rstatus[SMK_RLIM_SWITCH]);
	    }
	    _smk_session_decrease(oldses);
	    current->smk_ses[i]=NULL;
	}
	if(t1 == 0) continue;
	ses=_smk_getsession(); if(!ses) continue;
	current->smk_ses[i]=ses;
	ses->token = t1;
	ses->token_type = i;
	ses->id = ++smk_ses_next_id;
	ses->killid = killid;
	atomic_inc(&smk_sescnt);
	do_gettimeofday(&now);
	ses->start_time = now.tv_sec;
	memmove(ses->rlim,rlim,sizeof(ses->rlim));
	ses->rlim[0] <<= 20-PAGE_SHIFT;
	ses->rlim[1] <<= 20-PAGE_SHIFT;
	memset(ses->rstatus,0,sizeof(ses->rstatus));
	atomic_set(&ses->rstatus[SMK_RLIM_NPROC],1);
	current->fork_depth[i] = 0;
    }
}

	/* check rlim [type] against v: returns 1 if OK. */
long smk_rlim_exceed(unsigned long v, int type)
{
    int i, t;
    struct smk_session *ses;

    for(i = 0; i<SMK_SESSIONS; i++) {
	ses = current->smk_ses[i];
	if(!ses) continue;
	t = ses->rlim[type];
	if(t && v > t) return 1;
    }
    return 0;
}

	/* check rlim [type] against v: returns 0 if OK. */
long smk_rlim_reached(int type)
{
    unsigned int i, t;
    struct smk_session *ses;

    if(!smk_session_inited) return 0;
    for(i=0; i<SMK_SESSIONS; i++) {
	ses = current->smk_ses[i];
	if(!ses) continue;
	t = ses->rlim[type];
	if(t && atomic_read(&ses->rstatus[type]) >= t) return 1;
    }
    return 0;
}

	/* move triggered mask to active mask, then clean the former. */
static void _smk_trigger(struct sysmask_struct *smk)
{
    smk->active.m1|=smk->triggered.m1;
    smk->active.m2|=smk->triggered.m2;
    smk->active.cap|=smk->triggered.cap;
    smk->triggered.m1=smk->triggered.m2=smk->triggered.cap=0;
    smk->trigger=smk->tcnt=0;
}

	/* check trigger value and advance count. */
void smk_trigger(int t)
{
    if(!t || t!=current->smk.trigger) return;
    current->smk.tcnt--;
    if(current->smk.tcnt<=0) _smk_trigger(&current->smk);
}

static int _smk_daemon_connect(void)
{
    int i, retval;
    time_t asktime, checktime;
    struct timeval now;

    if(!smk_daemon_task) return -EACCES;	/* no daemon: deny every request */
    if(current==smk_daemon_task) return -EINVAL;	/* calling myself */
    if(current->pid == 0) return -EINVAL;	/* init process */
    if(_ultimatum()) return -EPERM;		/* time up */
    retval=-EAGAIN; asktime=0;

	/* This is not correct: we need to queue the requests. */
reloop:
    for(i=0; i<1000; i++) {
	spin_lock(&smkreq_lock);
	if(!smk_reqpid) break;
	spin_unlock(&smkreq_lock);
	if(!asktime) {
	    do_gettimeofday(&now); asktime = now.tv_sec;
	}
	yield();
    }
    if(i>=1000) {
	do_gettimeofday(&now); checktime = now.tv_sec;
	if(checktime < asktime + 2) goto reloop;
	else {
	    printk(KERN_DEBUG "Process %u: smkd connect timeout (%u).\n",current->pid,smk_reqpid);
	    goto out;
	}
    }
    smk_req.pid=0; retval=0; smk_reqpid=current->pid;
    smk_req.reqlen=0;
    spin_unlock(&smkreq_lock);
out:
    return retval;
}

static void _smk_daemon_abandon(void)
{
    spin_lock(&smkreq_lock);
    if(smk_reqpid == current->pid) smk_reqpid=smk_req.pid=0;
    spin_unlock(&smkreq_lock);
}


static int _smk_put_req_fname(const char *fname)
{
    unsigned long l,k;
    int err;
    static char cwd[SMK_PATH_MAX+1];
    char *e;
    struct vfsmount *pwdmnt;
    struct dentry *pwd;

    smk_req.fname[0]=0; smk_req_flags=0;
    l=strlen(fname);
    if(current->fs->rootmnt != smkd_rootmnt ||
       current->fs->root != smkd_root)
      smk_req_flags |= SMKD_REQ_ISCHROOT;
    pwdmnt=NULL; pwd=NULL;
    if(fname[0]!='/') {
	cwd[0] = 0;
	read_lock(&current->fs->lock);
	pwdmnt=mntget(current->fs->pwdmnt);
	pwd=dget(current->fs->pwd);
	read_unlock(&current->fs->lock);
	e=d_path(pwd, pwdmnt, cwd, SMK_PATH_MAX);
	dput(pwd); mntput(pwdmnt);
	if(IS_ERR(e)) {
	    err = PTR_ERR(e);
	    goto free_out;
	}
	k=strlen(e);
	if(k+l>=SMK_PATH_MAX-1) {
	    err = -ENAMETOOLONG;
	    goto free_out;
	}
	memmove(smk_req.fname,e,k);
	if(k>0 && smk_req.fname[k-1]!='/') smk_req.fname[k++]='/';
    }
    else k=0;
    if(k+l>=SMK_PATH_MAX) return -ENAMETOOLONG;
    memmove(smk_req.fname+k,fname,l+1);
    smk_req.reqlen=k+l;
    err = 0;
free_out:
    return err;
}

static long _smk_daemon_req(int type)
{
    int i,l;
    time_t asktime, checktime;
    struct timeval now;
    smk_req.uid=current->euid;
#ifdef LINUX_2_4
    smk_req.start_time=current->start_time;
#else
    smk_req.start_time=current->start_time.tv_sec;
#endif
    smk_req.sm1=current->smk.active.m1;
    smk_req.sm2=current->smk.active.m2;
    smk_req.syscall=current->smk_syscall&0xFFFF;
    smk_req.token=current->smk.token;
    smk_req.reqtype=type;
    if(current->smk_log_cnt>=SMK_LOG_LIM) smk_req.sm2&=~SM2_LOG;
    spin_lock(&smkreq_lock);
    smk_req.pid=current->pid;	/* this is the indicator for write end */
    spin_unlock(&smkreq_lock);
    wake_up_process(smk_daemon_task);
	/* smk_waiting for daemon */
    yield();
    if(smk_reqpid != current->pid && smk_waiting != current->pid) goto got;
    do_gettimeofday(&now); asktime = now.tv_sec;
    rewait:
    for(i=0;
	i<1000 && (smk_reqpid == current->pid || smk_waiting == current->pid);
	i++) yield();
    if(i>=1000) {	/* timeout: abandon */
	do_gettimeofday(&now); checktime = now.tv_sec;
	if(checktime < asktime + 10) goto rewait;
	_smk_daemon_abandon();
	return -EAGAIN;
    }

    got: l=current->smk_got.ind&0xFFFF;
    if(current->smk_got.ind&SMKD_ANS_LOGGED &&
       current->smk_log_cnt<SMK_LOG_LIM) current->smk_log_cnt++;
    current->smk_got.ind|=0xFFFF;
    return -l;
}

#define _smk_addmask(x) __smk_addmask(&current->smk,x)

	/* the principle is never remove an already-installed restriction */
static void __smk_addmask(struct sysmask_struct *dest, struct sysmask_struct *src)
{
    int i,j,k;
    if(src->trigger) {
	if(dest->trigger) {
	    if(dest->trigger!=src->trigger) _smk_trigger(dest);
	    else {
		if(dest->tcnt<src->tcnt)
		  src->tcnt=dest->tcnt;
	    }
	}
	dest->trigger=src->trigger;
	dest->tcnt=src->tcnt;
	dest->triggered.m1|=src->triggered.m1;
	dest->triggered.m2|=src->triggered.m2;
	dest->triggered.cap|=src->triggered.cap;
    }
    if(!dest->active.m1) k=1;
    else {
	for(i=k=0;i<SMK_EXCEPTS;i++) {
	    if(dest->except[i]==SMKD_EXCEPT) {
		k=1; break;
	    }
	}
    }
    for(i=0;i<SMK_EXCEPTS;i++) {
	if(src->except[i]>NR_sysmasks && 
	   (src->except[i]!=SMKD_EXCEPT || k==0)) {
	    src->except[i]=0;
	}
	if(src->except[i]!=0) {
	    for(j=0;j<SMK_EXCEPTS && src->except[i]!=dest->except[j];j++);
	    if(j>=SMK_EXCEPTS) {
		if(src->except[i]<=NR_sysmasks) {
		    if((sysmask_tab[src->except[i]-1]&dest->active.m1)!=0)
		      src->except[i]=0;
		}
		else if(dest->active.m1) src->except[i]=0;
	    }
	}
    }
    memmove(&dest->except,&src->except,SMK_EXCEPTS*sizeof(short));
    dest->active.m1|=src->active.m1;
    dest->active.m2|=src->active.m2;
    dest->active.cap|=src->active.cap;
}

	/* This one avoids mixing two tokens of the same level */
static void _smk_addtoken(signed long t)
{
    int err;
    int old_token = current->smk.token;
    
    if((t&0xFFFF) && (current->smk.token&0xFFFF)) t&=0xFFFF0000;
    if((t&0xFFFF0000) && (current->smk.token&0xFFFF0000)) t&=0xFFFF;
    err=_smk_daemon_connect();
    if(err) return;
    current->smk.token|=t;
    if(_smk_daemon_req(SMKD_REQ_TOKEN)) return;
    _smk_addmask(&current->smk_got.smk);
    _smk_new_session(old_token,current->smk.token,
		     current->smk_got.rlim,current->smk_got.killid);
}

	/* log syscall refusal by smkd */
static int _smk_log(int call,int check)
{
    int err;
    err=_smk_daemon_connect();
    if(err) return err;
    current->smk_syscall=call;
    if(check) return _smk_daemon_req(SMKD_REQ_CALL);
    else return _smk_daemon_req(SMKD_REQ_LOG);
}

static int _smk_masked(int syscall)
{
    int i,err;
    int dex = 0;
    syscall++;
    for(i=0;i<SMK_EXCEPTS && syscall!=current->smk.except[i];i++) {
	if(current->smk.except[i] == SMKD_EXCEPT) dex=1;
    }
    syscall--;
    if(syscall==current->smk.trigger) smk_trigger(syscall);
    if(i < SMK_EXCEPTS) return 0;
	/* log refusals */
    if(dex || (sm2_masked(SM2_LOG) && current->smk_log_cnt<SMK_LOG_LIM)) {
	err=_smk_log(syscall,dex);
	if(dex && !err) return 0;
	current->smk_log_cnt++;
    }
    return -EPERM;
}

	/* kill a single process */
static int _smk_killproc(long pid, long start_time)
{
    struct task_struct *p;
    read_lock(&tasklist_lock);
    p = find_task_by_pid(pid);
#ifdef LINUX_2_4
    if(!p || p->start_time != start_time) {
#else
    if(!p || p->start_time.tv_sec != start_time) {
#endif
	read_unlock(&tasklist_lock); return -EINVAL;
    }
    smk_kill(p);
    read_unlock(&tasklist_lock);
    return 0;
}

	/* kill a whole session */
static int _smk_killses(long sid)
{
    struct task_struct *p;

    read_lock(&tasklist_lock);
#ifdef LINUX_2_4
    for_each_task(p) {
#else
    for_each_process(p) {
#endif
	if((p->smk_ses[0] && p->smk_ses[0]->killid == sid) ||
	   (p->smk_ses[1] && p->smk_ses[1]->killid == sid))
	  smk_kill(p);
    }
    read_unlock(&tasklist_lock);
    return 0;
}

static int _smk_getreq(void __user * smk, size_t len)
{
    int err, t;
    size_t l;
    static int cnt = 0;
    struct task_struct *p;
    
    if(len > sizeof(smk_req)) len = sizeof(smk_req);
    if(cnt < 0) cnt = 0;
    spin_lock(&smkreq_lock);
    t = smk_req.pid - smk_reqpid;
    spin_unlock(&smkreq_lock);
    if(t != 0) {	/* half-done request */
	cnt++;
	if(cnt > 30) {	/* Stray request? Kill it. */
	    printk(KERN_ERR "smkd: stray requester %u killed.\n", smk_reqpid);
	    if(smk_reqpid > 1 && smk_reqpid != current->pid) sys_kill(smk_reqpid,SIGKILL);
	    spin_lock(&smkreq_lock);
	    smk_reqpid = 0; cnt = 0;
	    spin_unlock(&smkreq_lock);
	}
	return -EINVAL;
    }
    cnt=0;
    smk_req.reqtype|=smk_req_flags;
    if(smk_req.reqlen<0) smk_req.reqlen=0;
    l=sizeof(smk_req)-SMK_PATH_MAX+smk_req.reqlen;
    if(l>len) {	/* too long; should only occur under unequal versions */
	read_lock(&tasklist_lock);
	p = find_task_by_pid(smk_reqpid);
	if(p) p->smk_got.ind=ENAMETOOLONG;
	read_unlock(&tasklist_lock);
	err = -ENAMETOOLONG;
	spin_lock(&smkreq_lock);
	smk_waiting = 0;
	goto release_out;
    }
    err = copy_to_user(smk,&smk_req,l);
    spin_lock(&smkreq_lock);
    smk_waiting=smk_req.pid;
release_out:
    smk_reqpid = 0;	/* can receive new requests */
    spin_unlock(&smkreq_lock);
    return err;
}

static int _smk_smkdrep(void __user * smk, size_t len)
{
    struct task_struct *p;
    struct smkd_answer ans;
    
    if(len > sizeof(ans)) len = sizeof(ans);
    if(len < sizeof(ans)) memset(&ans,0,sizeof(ans));
    if(copy_from_user(&ans,smk,len))
      return -EFAULT;
    if(ans.ind & SMKD_ANS_KILL) {	/* kill the named process */
	if(!ans.smk.active.m1) return 0;	/* nothing to kill */
	if(ans.opt==0) {
	    if(ans.smk.active.m1==smk_waiting) smk_waiting=0;
	    return _smk_killproc(ans.smk.active.m1,ans.smk.active.m2);
	}
	else {
	    return _smk_killses(ans.smk.active.m1);
	}
    }
    if(!smk_waiting) return -EINVAL;
    read_lock(&tasklist_lock);
    p = find_task_by_pid(smk_waiting);
    if(!p) {	/* task disappeared */
	read_unlock(&tasklist_lock);
	smk_waiting = 0;
	return -EINVAL;
    }
    p->smk_got = ans;
    read_unlock(&tasklist_lock);
    smk_waiting=0;
    yield();
    return 0;
}

static int _smk_smkdreg(long l)
{
    struct timeval now;
    int oldtime, testime;
    
    if(current->euid!=0 || current->uid!=0 || sm2_masked(SM2_KILLSMKD))
	return -EPERM;
    if(smk_daemon_pid == current->pid) return 0;
    do_gettimeofday(&now);
    testime = now.tv_sec;
	/* This following situation only occurs if there is a bug in smkd.
	 * The codes are there to limit the consequences of the bug. */
    if(smk_daemon_pid != 0) {
	oldtime = atomic_read(&smkd_tick_time);
		/* another daemon is alive */
	if(oldtime <= testime && oldtime > testime - 15)
		return -EPERM;
	smk_kill(smk_daemon_task);
    }
    smkd_rootmnt = current->fs->rootmnt;
    smkd_root = current->fs->root;
    atomic_set(&smkd_tick_time,testime);
    sysmask_denyid=l;
    smkreq_lock=SPIN_LOCK_UNLOCKED;
    smk_daemon_pid=current->pid;
    smk_daemon_task=current;
    if(!smk_session_inited) _smk_init_ses();
    printk(KERN_WARNING "smkd: process %u registered.\n", smk_daemon_pid);
    return 0;
}

static int _smk_gettick(void)
{
    struct timeval now;
    
    do_gettimeofday(&now);
    atomic_set(&smkd_tick_time,now.tv_sec);
    return 0;
}

static int _smk_getmask2(void __user * smk, size_t l)
{
    int i, err, t1, t2, shift;
    int pid;
    struct task_struct *p;
    struct sysmask_struct s;

    err = copy_from_user(&s, smk, sizeof(struct sysmask_struct));
    if(err) return err;
    pid=s.token;
    if (pid<=0) return -EINVAL;
    if (pid == 1 || pid == smk_daemon_pid) return -EACCES;
    read_lock(&tasklist_lock);
    p = find_task_by_pid(pid);
    read_unlock(&tasklist_lock);
    if(!p) {	/* task disappeared */
	err = -ESRCH; goto ret;
    }
		/* Here race condition in target process
		 * will result in corrupt data collected or even segfault.
		 * Worth locking kernel for that? Maybe not. */
    err=-EACCES;
    if (current->euid != 0 && p->euid != current->euid) goto ret;
    t1=current->smk.token; t2=p->smk.token;
    if((t1&0xFFFF) && (t1&0xFFFF) != (t2&0xFFFF)) goto ret;
    if((t1&0xFFFF) && (t1&0xFFFF0000) &&
       (t1&0xFFFF0000) != (t2&0xFFFF0000)) goto ret;
    err = copy_to_user(smk,&p->smk,sizeof(struct sysmask_struct));
    if(err) goto ret;
    shift = sizeof(struct sysmask_struct);
	/* session information */
    for(i=0; l >= shift + sizeof(struct smk_session) && i<SMK_SESSIONS; i++) {
	if(p->smk_ses[i]) {
	    err = copy_to_user(smk+shift,p->smk_ses[i],sizeof(struct smk_session));
	    if(err) goto ret;
	}
	shift += sizeof(struct smk_session);
    }
ret:
    return err;
}

	/* this one is performance-critical. */
asmlinkage int sys_checkmask(int syscall)
{
#ifdef SMK_DISABLE
    return 0;
#endif
    if(syscall<0) return -ENOSYS;
    if(syscall>=NR_sysmasks) {
	if(sm1_masked(SM1_NEW|SM1_NONSTD)) return -EPERM;
	else return 0;
    }
    if(sm1_masked(sysmask_tab[syscall]) && _smk_masked(syscall)) {
	return -EPERM;
    }
    else if(syscall==current->smk.trigger) smk_trigger(syscall);
    current->smk_got.ind=0; current->smk_syscall=syscall;
    return 0;
}

	/* userspace program interface */
asmlinkage long sys_sysmask(long req, void __user * smk, long l)
{
    switch(req) {
	case SMK_VERSION: return SYSMASK_VERSION;
	case SMK_GETMASK: {
	    if(l != sizeof(struct sysmask_struct)) return -EINVAL;
	    copy_to_user(smk,&current->smk,sizeof(struct sysmask_struct));
	    return 0;
	}
	case SMK_SETMASK: {
	    struct sysmask_struct newmask;
	    int err;
	    if(l!=sizeof(struct sysmask_struct)) return -EINVAL;
	    err=copy_from_user(&newmask,smk,l);
	    if(err) return err;
	    _smk_addmask(&newmask);
	    if(newmask.token) _smk_addtoken(newmask.token);
	    return 0;
	}
	case SMK_TRIGGER: {
	    _smk_trigger(&current->smk);
	    return 0;
	}
	case SMK_RESERVE1: {
	    return -EINVAL;
	}
	case SMK_SMKDREQ: {	/* get request */
	    if(current!=smk_daemon_task) return -EPERM;
	    spin_lock(&smkreq_lock);
	    if(!smk_reqpid) {	/* no request */
		spin_unlock(&smkreq_lock);
		return -EAGAIN;
	    }
	    spin_unlock(&smkreq_lock);
	    return _smk_getreq(smk,l);
	}
	case SMK_SMKDREP: {	/* give reply */
	    if(current!=smk_daemon_task) return -EPERM;
	    return _smk_smkdrep(smk, l);
	}
	case SMK_SMKDREG: {	/* daemon registration */
	    return _smk_smkdreg(l);
	}
	case SMK_GETMASK2: {		/* get mask of another process. */
	    if(l < sizeof(struct sysmask_struct)) return -EINVAL;
	    return _smk_getmask2(smk,l);
	}
	case SMK_SETMASK2: {		/* not implemented */
	    return -EINVAL;
	}
	case SMK_SESSIONCNT: {
	    if(current->euid!=0 || current->uid!=0 ||
	       sm2_masked(SM2_KILLSMKD))
	      return -EPERM;
	    if(!smk_session_inited) _smk_init_ses();
	    return atomic_read(&smk_sescnt);
	}
	case SMK_TICK: {
	    if(current!=smk_daemon_task) return -EPERM;
	    return _smk_gettick();
	}
	default: return -EINVAL;	/* invalid request. */
    }
    return 0;
}

long smk_checkexec(const char *fname)
{
    int err;
    
#ifdef SMK_DISABLE
    return 0;
#endif
    if(!current->smk.token) return -EACCES;
    current->smk_got.ind=0;
    err=_smk_daemon_connect();
    if(err) return err;
    err=_smk_put_req_fname(fname);
    if(err) {_smk_daemon_abandon(); return err;}
    current->total_link_count = 0;
    return _smk_daemon_req(SMKD_REQ_EXEC);
}

long smk_checkexec2(struct file *file)
{
    int err, ind;
    struct smkd_answer save_ans;
    char *buf, *e;

#ifdef SMK_DISABLE
    return 0;
#endif
    ind=current->smk_got.ind;
    current->smk_got.ind &= 0xFFFF0000;	/* allow for interpreter check */
    if(current->total_link_count > 0 && (ind & SMKD_ANS_NOSLINK)) {
	return -EACCES;
    }
    if((ind & SMKD_ANS_NOHLINK) && file->f_dentry->d_inode->i_nlink>1) {
	return -EACCES;
    }
    if((!current->total_link_count && !(ind&SMKD_ANS_HASDOTDOT)) ||
       !(ind & SMKD_ANS_FOLLOW)) return 0;
    buf = (char *) __get_free_pages(GFP_KERNEL,1);
    if(!buf) return -EFAULT;
    e=d_path(file->f_dentry, file->f_vfsmnt, buf, SMK_PATH_MAX);
    if(IS_ERR(e)) {
	err = PTR_ERR(e);
	goto free_out;
    }
    save_ans = current->smk_got;
    err = smk_checkexec(e);
    if(!err && (current->smk_got.ind & SMKD_ANS_ADDMASK)) {
	__smk_addmask(&save_ans.smk,&current->smk_got.smk);
    }
    save_ans.ind &= ~(SMKD_ANS_FOLLOW|SMKD_ANS_HASDOTDOT);
    current->smk_got = save_ans;
free_out:
    free_pages((unsigned long) buf,1);
    return err;
}

long smk_check_end(void)
{
#ifdef SMK_DISABLE
    return 0;
#endif
	/* tick triggering */
    if((current->smk_got.ind & SMKD_ANS_TICK) && current->smk.trigger
       && current->smk.tcnt > 0) {
	current->smk.tcnt--;
	if(current->smk.tcnt<=0) _smk_trigger(&current->smk);
    }
    if(current->smk_got.ind & SMKD_ANS_NEWMASK) {
	_smk_new_session(current->smk.token,
			 current->smk_got.smk.token,
			 current->smk_got.rlim,
			 current->smk_got.killid);
	current->smk=current->smk_got.smk;
    }
    else if(current->smk_got.ind & SMKD_ANS_ADDMASK) {	/* add new mask to old one */
	_smk_addmask(&current->smk_got.smk);
    }
    current->smk_got.ind &= ~(SMKD_ANS_NEWMASK|SMKD_ANS_ADDMASK|SMKD_ANS_TICK);
    return 0;
}

static long _smk_checkpath(const char *fname)
{
    int err, call;
    struct smkd_answer save_ans;
    
    if(!current->smk.token) return -EACCES;	/* always deny if no token */
    call=current->smk_syscall&0xFFFF;
    if(call == __NR_execve) save_ans = current->smk_got;
    err=_smk_daemon_connect();
    if(err) return err;
    err=_smk_put_req_fname(fname);
    if(err) {_smk_daemon_abandon(); return err;}
    smk_req.flags = 0;
    if((current->smk.active.m2&(SM2_PATH|SM2_ROPEN))==(SM2_PATH|SM2_ROPEN)
       || call == __NR_execve)
      smk_req.flags = 1;
    if(call < NR_sysmasks && (sysmask_tab[call] & (SM1_DWRITE|SM1_ROOTMISC|SM1_SOCKETCALL))
       && sm2_masked(SM2_WOPEN)) {
	smk_req.flags |= 2;
    }
    else if(!smk_req.flags) {
	_smk_daemon_abandon(); return 0;
    }
    err = _smk_daemon_req(SMKD_REQ_OPEN);
    if(call == __NR_execve) current->smk_got = save_ans;
    current->smk_got.ind &= 0xFFFF0000; 	/* there may be more checks */
    return err;
}

long smk_checkpath(const char *fname)
{
    int err;
#ifdef SMK_DISABLE
    return 0;
#endif
    if(current->smk_got.ind & 0xFFFF) return 0;	/* already checked */
    err = _smk_checkpath(fname);
    if((current->smk_syscall&0xFFFF) != __NR_execve) smk_check_end();
    return err;
}

long smk_recheckpath(struct nameidata *nd)
{
    int call, l;
    int err;
    char *buf;
    char *e;

#ifdef SMK_DISABLE
    return 0;
#endif
    if(current->smk_got.ind&0xFFFF) return 0; /* should be checked elsewhere */
    if(current->total_link_count > 0 && (current->smk_got.ind & SMKD_ANS_NOSLINK)) {
	return -EACCES;
    }
    if(!sm2_masked(SM2_WOPEN)) return 0;
    call=current->smk_syscall&0xFFFF;
	/* only recheck writing */
    if(call>=NR_sysmasks || !(sysmask_tab[call] & (SM1_DWRITE|SM1_ROOTMISC))) {
	return 0;
    }
	/* no recheck if no symbolic links nor dotdot */
    if(!(current->smk_got.ind & SMKD_ANS_FOLLOW) ||
       (!current->total_link_count && !(current->smk_got.ind & SMKD_ANS_HASDOTDOT))) {
	return 0;
    }
    buf = (char *) __get_free_pages(GFP_KERNEL,1);
    if(!buf) return -EFAULT;
    e=d_path(nd->dentry, nd->mnt, buf, SMK_PATH_MAX);
    if(IS_ERR(e)) {
	err = PTR_ERR(e);
	goto free_out;
    }
    if(nd->last_type == LAST_NORM && nd->last.len) {
	l=strlen(e); memmove(buf,e,l+1); e=buf;
	if(l>=SMK_PATH_MAX - nd->last.len - 1) {
	    err = -ENAMETOOLONG;
	    goto free_out;
	}
	buf[l++]='/'; memmove(buf+l,nd->last.name,nd->last.len);
	buf[l+nd->last.len]=0;
    }
    err = _smk_checkpath(e);
free_out:
    free_pages((unsigned long) buf,1);
    return err;
}

long smk_checksymlink(const char *from, const char *to)
{
    char *buf;
    int l1, l2, err;
    
#ifdef SMK_DISABLE
    return 0;
#endif
    if(*from=='/') return smk_checkpath(from);
    l1=strlen(from);
    for(l2=strlen(to); l2>0 && to[l2-1]!='/'; l2--);
    if(l1+l2 >= SMK_PATH_MAX) return -ENAMETOOLONG;
    buf = (char *) __get_free_pages(GFP_KERNEL,1);
    if(!buf) return -EFAULT;
    memmove(buf,to,l2); memmove(buf+l2,from,l1); buf[l1+l2]=0;
    err = smk_checkpath(buf);
    free_pages((unsigned long) buf,1);
    return err;
}

static long _smk_checkopen(const char *fname, int *flag, int type)
{
    int acc,req,rem;
    int err;

    if(sm2_masked(SM2_CREAT)) *flag&=~(O_CREAT|O_TRUNC);
    if((*flag&3)==0) return -EINVAL;
    req=0;
    if(sm2_masked(SM2_ROPEN)) req|=1;
    if(sm2_masked(SM2_WOPEN)) req|=2;
    acc=*flag&req;
    if(!acc) return 0;
    rem=*flag&~req; err=-EACCES;
		/* no token: always refuse. */
    if(!current->smk.token) {
	ret_rem:
	if(rem&3) {
	    *flag=rem; return 0;	/* return allowed flags */
	}
	else return err;
    }
    err=_smk_daemon_connect();
    if(err) return err;
    err=_smk_put_req_fname(fname);
    if(err) {_smk_daemon_abandon(); return err;}
    smk_req.flags=*flag;
    err=_smk_daemon_req(type);
    if(err) {
	rem=current->smk_got.opt;
	goto ret_rem;
    }
    current->total_link_count=0;
    return 0;
}

long smk_checkopen(const char *fname, int *flag)
{
    int err;
    
#ifdef SMK_DISABLE
    return 0;
#endif
    if(!sm2_masked(SM2_OPEN2|SM2_CREAT)) return 0;
    current->smk_got.ind &= 0xFFFF;
    err = _smk_checkopen(fname,flag,SMKD_REQ_OPEN);
    smk_check_end();
    return err;
}

static long _smk_recheckopen(struct nameidata *nd, int flag)
{
    int save_flag, err;
    char *buf;
    char *e;

    if(current->total_link_count > 0 && (current->smk_got.ind & SMKD_ANS_NOSLINK)) {
	return -EACCES;
    }
    buf = (char *) __get_free_pages(GFP_KERNEL,1);
    if(!buf) return -EFAULT;
    e=d_path(nd->dentry, nd->mnt, buf, SMK_PATH_MAX);
    if(IS_ERR(e)) {
	err = PTR_ERR(e);
	goto free_out;
    }
    save_flag=flag;
    err=_smk_checkopen(e,&flag,SMKD_REQ_OPEN);
    if(err) goto free_out;
    err = -EACCES;
    if(save_flag != flag) goto free_out;
	/* No token nor tick is taken into account at this stage */
    if(current->smk_got.ind & SMKD_ANS_ADDMASK) {/* second set of masks */
	_smk_addmask(&current->smk_got.smk);
	current->smk_got.ind &= ~SMKD_ANS_ADDMASK;
    }
    err = 0;
free_out:
    free_pages((unsigned long) buf,1);
    return err;
}

long smk_openmode(struct nameidata *nd, int flag)
{
    struct inode *inode = nd->dentry->d_inode;
    int mode = inode->i_mode;
    int err;

#ifdef SMK_DISABLE
    return 0;
#endif
	/* hardlink check */
    if(!(inode->i_mode & S_IFDIR) && 
       (current->smk_got.ind & SMKD_ANS_NOHLINK) && inode->i_nlink>1)
      return -EACCES;
	/* symlink check */
    if(current->total_link_count > 0 && (current->smk_got.ind & SMKD_ANS_NOSLINK)) {
	return -EACCES;
    }
	/* recheck path if symbolic links are followed */
    if((current->smk_got.ind & SMKD_ANS_FOLLOW) && 
       (current->total_link_count > 0 || (current->smk_got.ind & SMKD_ANS_HASDOTDOT))) {
	err=_smk_recheckopen(nd, flag);
	if(err) return err;
    }
	/*
	 * Do not allow writing to executable files
	 * when chmod is masked.
	 */
    if (sm1_masked(SM1_CHMOD) && (flag & FMODE_WRITE)
	&& (mode & S_IXUGO)) {
	return -EACCES;
    }
    if (sm2_masked(SM2_DEV) && (S_ISCHR(mode) || S_ISBLK(mode)) &&
	(S_ISBLK(mode) || MAJOR(inode->i_rdev)!=1 || MINOR(inode->i_rdev)!=3)) { /* /dev/null is allowed */
	char buf[32];
	char c;
	int fl = flag;
	if(S_ISBLK(mode)) c='b'; else c='c';
	snprintf(buf,sizeof(buf),"/%c/%u/%u",c,MAJOR(inode->i_rdev),MINOR(inode->i_rdev));
	err=_smk_checkopen(buf,&fl,SMKD_REQ_DEV);
	if(err) return err;
	if(fl != flag) return -EACCES;
    }
    if (sm2_masked(SM2_PROCFS)) {	/* lock? */
	if(memcmp(nd->mnt->mnt_sb->s_type->name,"proc",5)==0)
	  return -EACCES;
    }
    return 0;
}

	/* this is only a template for the time being */
long smk_checksocket(struct socket *sock, int type,
		      struct sockaddr __user *addr, int addrlen)
{
    char *cp;
    int *ip;
    int err;
    struct smkd_answer save_ans;

    if(current->smk_syscall == __NR_execve) save_ans = current->smk_got;
    current->smk_got.ind = 0;
    err = -ENAMETOOLONG;
    if(addrlen < 0) goto out;
    if(!addr) addrlen=0;
    err = 0;
    if(addrlen==0 && type==SYS_SEND) goto out;
    err = -ENAMETOOLONG;
    if(addrlen+3*sizeof(int) >= SMK_PATH_MAX) goto out;
    err = -EACCES;
    if(!current->smk.token) goto out;
    err=_smk_daemon_connect();
    if(err) goto out;
    ip=(int *) smk_req.fname; 
    ip[0]=type; ip[1]=sock->ops->family; ip[2]=sock->type;
    cp=smk_req.fname+3*sizeof(int);
    if(addrlen>0) {
	if(type != SYS_SEND && type != SYS_RECV) {
	    err = copy_from_user(cp, addr, addrlen);
	    if(err) {_smk_daemon_abandon();goto out;}
	}
	else memmove(cp,addr,addrlen);
    }
    smk_req.reqlen=addrlen+3*sizeof(int);
    
    err = _smk_daemon_req(SMKD_REQ_SOCKET);
    smk_check_end();
out:
    if(current->smk_syscall == __NR_execve) current->smk_got = save_ans;
    return err;
}

	/* Fork limit check */
long smk_checkfork(void)
{
    int i;
    struct smk_session *ses;
    unsigned long t, nowsec;
    struct timeval now;

#ifdef SMK_DISABLE
    return 0;
#endif
    if(!smk_session_inited) {
	_smk_init_ses();
	return 0;
    }
    if(_ultimatum()) return -EPERM;
    if(smk_rlim_reached(SMK_RLIM_FORK)) return -EPERM;
    if(smk_rlim_reached(SMK_RLIM_NPROC)) return -EAGAIN;
    do_gettimeofday(&now); nowsec=now.tv_sec;
    for(i=0; i<SMK_SESSIONS; i++) {
	ses = current->smk_ses[i];
	if(!ses) continue;
	if(atomic_read(&ses->fork_time) != (nowsec & 0xFFFF)) {
	    atomic_set(&ses->fork_time, nowsec & 0xFFFF);
	    atomic_set(&ses->rstatus[SMK_RLIM_FORKFREQ], 0);
	}
	t = ses->rlim[SMK_RLIM_FORKDEPTH];
	if(t && current->fork_depth[i] >= t) return -EPERM;
    }
    if(smk_rlim_reached(SMK_RLIM_FORKFREQ)) return -EAGAIN;
    return 0;
}

	/* set sysmask for fork child */
void smk_forked(struct task_struct *p)
{
    int i;
    
    memmove(&p->smk,&current->smk,sizeof(struct sysmask_struct));
    memmove(p->smk_ses, current->smk_ses, sizeof(current->smk_ses));
    p->smk_log_cnt = 0;
    if(!smk_session_inited) return;
    for(i=0; i<SMK_SESSIONS; i++) {
	if(p->smk_ses[i]) {
	    atomic_inc(&p->smk_ses[i]->rstatus[SMK_RLIM_FORK]);
	    atomic_inc(&p->smk_ses[i]->rstatus[SMK_RLIM_FORKFREQ]);
	    atomic_inc(&p->smk_ses[i]->rstatus[SMK_RLIM_NPROC]);
	    p->fork_depth[i] = current->fork_depth[i]+1;
	}
    }
}

	/* release session count for an exited task. */
void smk_exited(struct task_struct *p)
{
    int i;

    if(!smk_session_inited) {
	_smk_init_ses();
	return;
    }
    for(i=0; i<SMK_SESSIONS; i++) {
	_smk_session_decrease(p->smk_ses[i]);
	p->smk_ses[i]=NULL;
    }
}

