/*    Copyright (C) 2005 XIAO, Gang of Universite de Nice - Sophia Antipolis
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	/* Token file reading. */

char tokenbuf[TOKENBUFLEN];
char *tokenn[131072];
struct tokens {
    char *token;
    int n;
} tokens[131072];
int tokencnt;
time_t tokentime;

void gettokens(void)
{
    struct stat st;
    char *p1, *p2, *p3;
    int j,s,t;

    if(stat(tokenfile,&st)) {	/* token file not found */
	memset(tokenn,0,sizeof(tokenn)); tokencnt=0;
	return;
    }
    if(st.st_mtime<=tokentime) return;	/* not modified */
    memset(tokenn,0,sizeof(tokenn));
    tokentime=st.st_mtime;
    readfile(tokenfile,tokenbuf,sizeof(tokenbuf));
    for(tokencnt=0, p1=tokenbuf; *p1; p1=p2) {
	p2=find_line_end(p1); if(*p2) *p2++=0;
	p1=find_word_start(p1);
	if(!myisalnum(*p1)) continue;
	p3=find_word_end(p1); if(*p3==0) continue;
	*p3++=0; p3=find_word_start(p3);
	*find_word_end(p3)=0;
	switch(*p3) {
	    case 's': s=0; break;
	    case 'u': s=65536; break;
	    default: s=-1; break;
	}
	if(s<0) continue;
	t=str2int(++p3); if(t<0 || (t&0xFFFF0000)) continue;
	t+=s;
	if(tokenn[t]) continue;	/* double definition */
	j=search_list(tokens,tokencnt,sizeof(tokens[0]),p1);
	if(j>=0) continue;	/* double definition */
	j=~j; memmove(tokens+j+1,tokens+j,(tokencnt-j)*sizeof(tokens[0]));
	tokencnt++;
	tokens[j].token=p1; tokens[j].n=t;
	tokenn[t]=p1;
    }
}

	/* This one avoids mixing two tokens of the same level */
void addtoken(long *token, long t)
{
    if((t&0xFFFF) && (*token&0xFFFF)) return;
    if((t&0xFFFF0000) && (*token&0xFFFF0000)) return;
    *token|=t;
}

unsigned long token_expand(int t)
{
    if(!(t&0xFFFF0000)) return t;
    else return (t&0xFFFF)<<16;
}

